<template>
    <div class="row">
        <div class="col-md-8">
            <h1>{{ post.title }}</h1>
            <span class="h6 font-italic">{{ post.author }} {{post.date}}</span>
            <div class="border-bottom py-2" v-html="post.content"></div>
            <div class="images border-bottom py-2" v-if="post.img_base64">

                <v-lazy-image v-for="(data_base64, key) in post.img_base64"
                              class="img-fluid"
                              :src="'data:image/jpeg;base64,'+ data_base64"
                              :key="key"
                ></v-lazy-image>

            </div>
            <div class="btn-group py-2" role="group" aria-label="Actions">
                <button type="button"
                        v-if="currentUser === post.author_id"
                        @click="deletePost(post.id)"
                        class="btn btn-sm btn-danger">Delete
                </button>
            </div>
            <comments
                v-cloak
                :post-owner-id="post.author_id"
            >
            </comments>
        </div>

    </div>
</template>

<script>
    import Comments from '../comments/Comments.vue';
    import VLazyImage from "v-lazy-image";

    export default {
        name: 'post',
        components: {
            Comments,
            VLazyImage
        },

        data() {
            return {
                post: []
            }
        },
        computed: {
            currentUser() {
                if (this.$store.getters.currentUser !== null) {
                    return this.$store.getters.currentUser.id;
                }
                return 0;
            }
        },
        methods: {
            getPost() {
                axios.get(`/api/v1/posts/${this.$route.params.id}`)
                    .then((response) => {
                        this.post = response.data.data;
                        this.$store.dispatch('setPostId', this.post.id);
                        this.$store.dispatch("loadComments", this.post.id);
                    });
            },
            deletePost(id) {
                this.$store.dispatch('deletePost', {id: id});
                this.$router.push('/');
            }
        },

        created() {
            this.getPost();
        }
    }
</script>
